Enable historical metrics ingestion

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

POST https://api.ap1.datadoghq.com/api/v2/metrics/historical-metrics-configurationshttps://api.ap2.datadoghq.com/api/v2/metrics/historical-metrics-configurationshttps://api.datadoghq.eu/api/v2/metrics/historical-metrics-configurationshttps://api.ddog-gov.com/api/v2/metrics/historical-metrics-configurationshttps://api.us2.ddog-gov.com/api/v2/metrics/historical-metrics-configurationshttps://api.uk1.datadoghq.com/api/v2/metrics/historical-metrics-configurationshttps://api.datadoghq.com/api/v2/metrics/historical-metrics-configurationshttps://api.us3.datadoghq.com/api/v2/metrics/historical-metrics-configurationshttps://api.us5.datadoghq.com/api/v2/metrics/historical-metrics-configurations

개요

메트릭에 대한 과거 메트릭 수집(지연 데이터 수집)을 활성화합니다. 멱등성: 이미 활성화된 메트릭을 활성화하면 201 대신 200을 반환합니다. 분포 메트릭, 기존 태그 구성이 있는 메트릭 또는 대부분의 표준 (사용자 지정이 아닌) 메트릭에는 지원되지 않습니다. This endpoint requires the late_metrics_config_write permission.

OAuth apps require the late_metrics_config_write authorization scope to access this endpoint.

요청

Body Data (required)

Expand All

항목

유형

설명

data [required]

object

Data object for enabling historical metrics ingestion for a metric.

id [required]

string

The metric name, used as the resource ID.

type [required]

enum

The historical metrics configuration resource type. Allowed enum values: historical_metrics_configurations

default: historical_metrics_configurations

{
  "data": {
    "id": "dd.test.metric",
    "type": "historical_metrics_configurations"
  }
}

응답

OK

Response containing a historical metrics configuration.

Expand All

항목

유형

설명

data

object

A historical metrics configuration resource object. Existence of this resource means historical metrics ingestion is enabled for the metric; there is no separate enabled attribute.

attributes

object

Attributes of a historical metrics configuration.

created_at

date-time

Timestamp when historical metrics ingestion was enabled for the metric.

id

string

The metric name, used as the resource ID.

type

enum

The historical metrics configuration resource type. Allowed enum values: historical_metrics_configurations

default: historical_metrics_configurations

{
  "data": {
    "attributes": {
      "created_at": "2024-01-15T12:00:00.000Z"
    },
    "id": "dd.test.metric",
    "type": "historical_metrics_configurations"
  }
}

Created

Response containing a historical metrics configuration.

Expand All

항목

유형

설명

data

object

A historical metrics configuration resource object. Existence of this resource means historical metrics ingestion is enabled for the metric; there is no separate enabled attribute.

attributes

object

Attributes of a historical metrics configuration.

created_at

date-time

Timestamp when historical metrics ingestion was enabled for the metric.

id

string

The metric name, used as the resource ID.

type

enum

The historical metrics configuration resource type. Allowed enum values: historical_metrics_configurations

default: historical_metrics_configurations

{
  "data": {
    "attributes": {
      "created_at": "2024-01-15T12:00:00.000Z"
    },
    "id": "dd.test.metric",
    "type": "historical_metrics_configurations"
  }
}

Bad Request

API error response.

Expand All

항목

유형

설명

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Not Found

API error response.

Expand All

항목

유형

설명

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Unprocessable Entity

API error response.

Expand All

항목

유형

설명

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

항목

유형

설명

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

코드 예시

                  ## default
# 

# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

# Curl command
curl -X POST "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/metrics/historical-metrics-configurations" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "Authorization: Bearer ${DD_BEARER_TOKEN}" \ -d @- << EOF { "data": { "id": "dd.test.metric", "type": "historical_metrics_configurations" } } EOF
"""
Enable historical metrics ingestion returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.metrics_api import MetricsApi
from datadog_api_client.v2.model.historical_metrics_configuration_create_data import (
    HistoricalMetricsConfigurationCreateData,
)
from datadog_api_client.v2.model.historical_metrics_configuration_create_request import (
    HistoricalMetricsConfigurationCreateRequest,
)
from datadog_api_client.v2.model.historical_metrics_configuration_type import HistoricalMetricsConfigurationType

body = HistoricalMetricsConfigurationCreateRequest(
    data=HistoricalMetricsConfigurationCreateData(
        id="dd.test.metric",
        type=HistoricalMetricsConfigurationType.HISTORICAL_METRICS_CONFIGURATIONS,
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
configuration.unstable_operations["create_historical_metrics_configuration"] = True
with ApiClient(configuration) as api_client:
    api_instance = MetricsApi(api_client)
    response = api_instance.create_historical_metrics_configuration(body=body)

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
# Enable historical metrics ingestion returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
  config.unstable_operations["v2.create_historical_metrics_configuration".to_sym] = true
end
api_instance = DatadogAPIClient::V2::MetricsAPI.new

body = DatadogAPIClient::V2::HistoricalMetricsConfigurationCreateRequest.new({
  data: DatadogAPIClient::V2::HistoricalMetricsConfigurationCreateData.new({
    id: "dd.test.metric",
    type: DatadogAPIClient::V2::HistoricalMetricsConfigurationType::HISTORICAL_METRICS_CONFIGURATIONS,
  }),
})
p api_instance.create_historical_metrics_configuration(body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" rb "example.rb"
// Enable historical metrics ingestion returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.HistoricalMetricsConfigurationCreateRequest{
		Data: datadogV2.HistoricalMetricsConfigurationCreateData{
			Id:   "dd.test.metric",
			Type: datadogV2.HISTORICALMETRICSCONFIGURATIONTYPE_HISTORICAL_METRICS_CONFIGURATIONS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateHistoricalMetricsConfiguration", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewMetricsApi(apiClient)
	resp, r, err := api.CreateHistoricalMetricsConfiguration(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `MetricsApi.CreateHistoricalMetricsConfiguration`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `MetricsApi.CreateHistoricalMetricsConfiguration`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
// Enable historical metrics ingestion returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.MetricsApi;
import com.datadog.api.client.v2.model.HistoricalMetricsConfigurationCreateData;
import com.datadog.api.client.v2.model.HistoricalMetricsConfigurationCreateRequest;
import com.datadog.api.client.v2.model.HistoricalMetricsConfigurationResponse;
import com.datadog.api.client.v2.model.HistoricalMetricsConfigurationType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    defaultClient.setUnstableOperationEnabled("v2.createHistoricalMetricsConfiguration", true);
    MetricsApi apiInstance = new MetricsApi(defaultClient);

    HistoricalMetricsConfigurationCreateRequest body =
        new HistoricalMetricsConfigurationCreateRequest()
            .data(
                new HistoricalMetricsConfigurationCreateData()
                    .id("dd.test.metric")
                    .type(HistoricalMetricsConfigurationType.HISTORICAL_METRICS_CONFIGURATIONS));

    try {
      HistoricalMetricsConfigurationResponse result =
          apiInstance.createHistoricalMetricsConfiguration(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling MetricsApi#createHistoricalMetricsConfiguration");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
// Enable historical metrics ingestion returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_metrics::MetricsAPI;
use datadog_api_client::datadogV2::model::HistoricalMetricsConfigurationCreateData;
use datadog_api_client::datadogV2::model::HistoricalMetricsConfigurationCreateRequest;
use datadog_api_client::datadogV2::model::HistoricalMetricsConfigurationType;

#[tokio::main]
async fn main() {
    let body = HistoricalMetricsConfigurationCreateRequest::new(
        HistoricalMetricsConfigurationCreateData::new(
            "dd.test.metric".to_string(),
            HistoricalMetricsConfigurationType::HISTORICAL_METRICS_CONFIGURATIONS,
        ),
    );
    let mut configuration = datadog::Configuration::new();
    configuration
        .set_unstable_operation_enabled("v2.create_historical_metrics_configuration", true);
    let api = MetricsAPI::with_config(configuration);
    let resp = api.create_historical_metrics_configuration(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
/**
 * Enable historical metrics ingestion returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
configuration.unstableOperations["v2.createHistoricalMetricsConfiguration"] =
  true;
const apiInstance = new v2.MetricsApi(configuration);

const params: v2.MetricsApiCreateHistoricalMetricsConfigurationRequest = {
  body: {
    data: {
      id: "dd.test.metric",
      type: "historical_metrics_configurations",
    },
  },
};

apiInstance
  .createHistoricalMetricsConfiguration(params)
  .then((data: v2.HistoricalMetricsConfigurationResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" tsc "example.ts"